//+------------------------------------------------------------------+
//|        Fractal_radar.mq4                                         |
//|                                                                  |
//|        Shane Lee                                                 |
//|        tradingmail@bigpond.com           alexptrans@gmail.com    |
//+------------------------------------------------------------------+
#property indicator_separate_window
//---- input parameters

   extern int search_period = 400;
   extern string font="Arial";
   extern color upper_rows_color= Red;
   extern color price_row_color= BurlyWood;
   extern color lower_rows_color= RoyalBlue;
   extern color period_color=DarkSlateGray;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   label ("sp",65,3);
   ObjectSetText("sp","("+DoubleToStr(search_period,0)+")",8,"Arial",White);
   
   return(0);
  }

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {

//---Row headings
   
   label ("PU10",30,20);
   label ("PU9",30,35);
   label ("PU8",30,50);
   label ("PU7",30,65);
   label ("PU6",30,80);
   label ("PU5",30,95);
   label ("PU4",30,110);
   label ("PU3",30,125);
   label ("PU2",30,140);
   label ("PU1",30,155);
   label ("P",15,170);
   label ("PD1",30,190);
   label ("PD2",30,205);
   label ("PD3",30,220);
   label ("PD4",30,235);
   label ("PD5",30,250);
   label ("PD6",30,265);
   label ("PD7",30,280);
   label ("PD8",30,295);
   label ("PD9",30,310);
   label ("PD10",30,325);

   ObjectSetText("PU10",DoubleToStr(Close[0]+Point*10,Digits),10,font,upper_rows_color);
   ObjectSetText("PU9",DoubleToStr(Close[0]+Point*9,Digits),10,font,upper_rows_color);
   ObjectSetText("PU8",DoubleToStr(Close[0]+Point*8,Digits),10,font,upper_rows_color);
   ObjectSetText("PU7",DoubleToStr(Close[0]+Point*7,Digits),10,font,upper_rows_color);
   ObjectSetText("PU6",DoubleToStr(Close[0]+Point*6,Digits),10,font,upper_rows_color);
   ObjectSetText("PU5",DoubleToStr(Close[0]+Point*5,Digits),10,font,upper_rows_color);
   ObjectSetText("PU4",DoubleToStr(Close[0]+Point*4,Digits),10,font,upper_rows_color);
   ObjectSetText("PU3",DoubleToStr(Close[0]+Point*3,Digits),10,font,upper_rows_color);
   ObjectSetText("PU2",DoubleToStr(Close[0]+Point*2,Digits),10,font,upper_rows_color);
   ObjectSetText("PU1",DoubleToStr(Close[0]+Point,Digits),10,font,upper_rows_color);
   ObjectSetText("P",DoubleToStr(Close[0],Digits),14,font,price_row_color);
   ObjectSetText("PD1",DoubleToStr(Close[0]-Point,Digits),10,font,lower_rows_color);
   ObjectSetText("PD2",DoubleToStr(Close[0]-Point*2,Digits),10,font,lower_rows_color);
   ObjectSetText("PD3",DoubleToStr(Close[0]-Point*3,Digits),10,font,lower_rows_color);
   ObjectSetText("PD4",DoubleToStr(Close[0]-Point*4,Digits),10,font,lower_rows_color);
   ObjectSetText("PD5",DoubleToStr(Close[0]-Point*5,Digits),10,font,lower_rows_color);
   ObjectSetText("PD6",DoubleToStr(Close[0]-Point*6,Digits),10,font,lower_rows_color);
   ObjectSetText("PD7",DoubleToStr(Close[0]-Point*7,Digits),10,font,lower_rows_color);
   ObjectSetText("PD8",DoubleToStr(Close[0]-Point*8,Digits),10,font,lower_rows_color);
   ObjectSetText("PD9",DoubleToStr(Close[0]-Point*9,Digits),10,font,lower_rows_color);
   ObjectSetText("PD10",DoubleToStr(Close[0]-Point*10,Digits),10,font,lower_rows_color);

//---Column headings
   label ("M1",100,1);
   label ("M5",150,1);
   label ("M15",200,1);
   label ("M30",250,1);
   label ("H1",300,1);
   label ("H4",350,1);
   label ("D1",400,1);
   label ("W1",450,1);
   label ("MN",500,1);

   ObjectSetText("M1","M1",12,font,period_color);
   ObjectSetText("M5","M5",12,font,period_color);
   ObjectSetText("M15","M15",12,font,period_color);
   ObjectSetText("M30","M30",12,font,period_color);
   ObjectSetText("H1","H1",12,font,period_color);
   ObjectSetText("H4","H4",12,font,period_color);
   ObjectSetText("D1","D1",12,font,period_color);
   ObjectSetText("W1","W1",12,font,period_color);
   ObjectSetText("MN","MN",12,font,period_color);

//---Data labels


   label ("PU10_M1",110,20);
   label ("PU10_M5",160,20);
   label ("PU10_M15",210,20);
   label ("PU10_M30",260,20);
   label ("PU10_H1",310,20);
   label ("PU10_H4",360,20);
   label ("PU10_D1",410,20);
   label ("PU10_W1",460,20);
   label ("PU10_MN",510,20);


   label ("PU9_M1",110,35);
   label ("PU9_M5",160,35);
   label ("PU9_M15",210,35);
   label ("PU9_M30",260,35);
   label ("PU9_H1",310,35);
   label ("PU9_H4",360,35);
   label ("PU9_D1",410,35);
   label ("PU9_W1",460,35);
   label ("PU9_MN",510,35);


   label ("PU8_M1",110,50);
   label ("PU8_M5",160,50);
   label ("PU8_M15",210,50);
   label ("PU8_M30",260,50);
   label ("PU8_H1",310,50);
   label ("PU8_H4",360,50);
   label ("PU8_D1",410,50);
   label ("PU8_W1",460,50);
   label ("PU8_MN",510,50);


   label ("PU7_M1",110,65);
   label ("PU7_M5",160,65);
   label ("PU7_M15",210,65);
   label ("PU7_M30",260,65);
   label ("PU7_H1",310,65);
   label ("PU7_H4",360,65);
   label ("PU7_D1",410,65);
   label ("PU7_W1",460,65);
   label ("PU7_MN",510,65);


   label ("PU6_M1",110,80);
   label ("PU6_M5",160,80);
   label ("PU6_M15",210,80);
   label ("PU6_M30",260,80);
   label ("PU6_H1",310,80);
   label ("PU6_H4",360,80);
   label ("PU6_D1",410,80);
   label ("PU6_W1",460,80);
   label ("PU6_MN",510,80);

   label ("PU5_M1",110,95);
   label ("PU5_M5",160,95);
   label ("PU5_M15",210,95);
   label ("PU5_M30",260,95);
   label ("PU5_H1",310,95);
   label ("PU5_H4",360,95);
   label ("PU5_D1",410,95);
   label ("PU5_W1",460,95);
   label ("PU5_MN",510,95);
   
   label ("PU4_M1",110,110);
   label ("PU4_M5",160,110);
   label ("PU4_M15",210,110);
   label ("PU4_M30",260,110);
   label ("PU4_H1",310,110);
   label ("PU4_H4",360,110);
   label ("PU4_D1",410,110);
   label ("PU4_W1",460,110);
   label ("PU4_MN",510,110);

   label ("PU3_M1",110,125);
   label ("PU3_M5",160,125);
   label ("PU3_M15",210,125);
   label ("PU3_M30",260,125);
   label ("PU3_H1",310,125);
   label ("PU3_H4",360,125);
   label ("PU3_D1",410,125);
   label ("PU3_W1",460,125);
   label ("PU3_MN",510,125);

   label ("PU2_M1",110,140);
   label ("PU2_M5",160,140);
   label ("PU2_M15",210,140);
   label ("PU2_M30",260,140);
   label ("PU2_H1",310,140);
   label ("PU2_H4",360,140);
   label ("PU2_D1",410,140);
   label ("PU2_W1",460,140);
   label ("PU2_MN",510,140);

   label ("PU1_M1",110,155);
   label ("PU1_M5",160,155);
   label ("PU1_M15",210,155);
   label ("PU1_M30",260,155);
   label ("PU1_H1",310,155);
   label ("PU1_H4",360,155);
   label ("PU1_D1",410,155);
   label ("PU1_W1",460,155);
   label ("PU1_MN",510,155);

   label ("P_M1",110,170);
   label ("P_M5",160,170);
   label ("P_M15",210,170);
   label ("P_M30",260,170);
   label ("P_H1",310,170);
   label ("P_H4",360,170);
   label ("P_D1",410,170);
   label ("P_W1",460,170);
   label ("P_MN",510,170);

   label ("PD1_M1",110,190);
   label ("PD1_M5",160,190);
   label ("PD1_M15",210,190);
   label ("PD1_M30",260,190);
   label ("PD1_H1",310,190);
   label ("PD1_H4",360,190);
   label ("PD1_D1",410,190);
   label ("PD1_W1",460,190);
   label ("PD1_MN",510,190);

   label ("PD2_M1",110,205);
   label ("PD2_M5",160,205);
   label ("PD2_M15",210,205);
   label ("PD2_M30",260,205);
   label ("PD2_H1",310,205);
   label ("PD2_H4",360,205);
   label ("PD2_D1",410,205);
   label ("PD2_W1",460,205);
   label ("PD2_MN",510,205);

   label ("PD3_M1",110,220);
   label ("PD3_M5",160,220);
   label ("PD3_M15",210,220);
   label ("PD3_M30",260,220);
   label ("PD3_H1",310,220);
   label ("PD3_H4",360,220);
   label ("PD3_D1",410,220);
   label ("PD3_W1",460,220);
   label ("PD3_MN",510,220);

   label ("PD4_M1",110,235);
   label ("PD4_M5",160,235);
   label ("PD4_M15",210,235);
   label ("PD4_M30",260,235);
   label ("PD4_H1",310,235);
   label ("PD4_H4",360,235);
   label ("PD4_D1",410,235);
   label ("PD4_W1",460,235);
   label ("PD4_MN",510,235);

   label ("PD5_M1",110,250);
   label ("PD5_M5",160,250);
   label ("PD5_M15",210,250);
   label ("PD5_M30",260,250);
   label ("PD5_H1",310,250);
   label ("PD5_H4",360,250);
   label ("PD5_D1",410,250);
   label ("PD5_W1",460,250);
   label ("PD5_MN",510,250);

   label ("PD6_M1",110,265);
   label ("PD6_M5",160,265);
   label ("PD6_M15",210,265);
   label ("PD6_M30",260,265);
   label ("PD6_H1",310,265);
   label ("PD6_H4",360,265);
   label ("PD6_D1",410,265);
   label ("PD6_W1",460,265);
   label ("PD6_MN",510,265);

   label ("PD7_M1",110,280);
   label ("PD7_M5",160,280);
   label ("PD7_M15",210,280);
   label ("PD7_M30",260,280);
   label ("PD7_H1",310,280);
   label ("PD7_H4",360,280);
   label ("PD7_D1",410,280);
   label ("PD7_W1",460,280);
   label ("PD7_MN",510,280);

   label ("PD8_M1",110,295);
   label ("PD8_M5",160,295);
   label ("PD8_M15",210,295);
   label ("PD8_M30",260,295);
   label ("PD8_H1",310,295);
   label ("PD8_H4",360,295);
   label ("PD8_D1",410,295);
   label ("PD8_W1",460,295);
   label ("PD8_MN",510,295);

   label ("PD9_M1",110,310);
   label ("PD9_M5",160,310);
   label ("PD9_M15",210,310);
   label ("PD9_M30",260,310);
   label ("PD9_H1",310,310);
   label ("PD9_H4",360,310);
   label ("PD9_D1",410,310);
   label ("PD9_W1",460,310);
   label ("PD9_MN",510,310);

   label ("PD10_M1",110,325);
   label ("PD10_M5",160,325);
   label ("PD10_M15",210,325);
   label ("PD10_M30",260,325);
   label ("PD10_H1",310,325);
   label ("PD10_H4",360,325);
   label ("PD10_D1",410,325);
   label ("PD10_W1",460,325);
   label ("PD10_MN",510,325);


   ObjectSetText("PU10_M1",Frac_counter(10,PERIOD_M1),10,font,upper_rows_color);
   ObjectSetText("PU10_M5",Frac_counter(10,PERIOD_M5),10,font,upper_rows_color);
   ObjectSetText("PU10_M15",Frac_counter(10,PERIOD_M15),10,font,upper_rows_color);
   ObjectSetText("PU10_M30",Frac_counter(10,PERIOD_M30),10,font,upper_rows_color);
   ObjectSetText("PU10_H1",Frac_counter(10,PERIOD_H1),10,font,upper_rows_color);
   ObjectSetText("PU10_H4",Frac_counter(10,PERIOD_H4),10,font,upper_rows_color);
   ObjectSetText("PU10_D1",Frac_counter(10,PERIOD_D1),10,font,upper_rows_color);
   ObjectSetText("PU10_W1",Frac_counter(10,PERIOD_W1),10,font,upper_rows_color);
   ObjectSetText("PU10_MN",Frac_counter(10,PERIOD_MN1),10,font,upper_rows_color);

   ObjectSetText("PU9_M1",Frac_counter(9,PERIOD_M1),10,font,upper_rows_color);
   ObjectSetText("PU9_M5",Frac_counter(9,PERIOD_M5),10,font,upper_rows_color);
   ObjectSetText("PU9_M15",Frac_counter(9,PERIOD_M15),10,font,upper_rows_color);
   ObjectSetText("PU9_M30",Frac_counter(9,PERIOD_M30),10,font,upper_rows_color);
   ObjectSetText("PU9_H1",Frac_counter(9,PERIOD_H1),10,font,upper_rows_color);
   ObjectSetText("PU9_H4",Frac_counter(9,PERIOD_H4),10,font,upper_rows_color);
   ObjectSetText("PU9_D1",Frac_counter(9,PERIOD_D1),10,font,upper_rows_color);
   ObjectSetText("PU9_W1",Frac_counter(9,PERIOD_W1),10,font,upper_rows_color);
   ObjectSetText("PU9_MN",Frac_counter(9,PERIOD_MN1),10,font,upper_rows_color);

   ObjectSetText("PU8_M1",Frac_counter(8,PERIOD_M1),10,font,upper_rows_color);
   ObjectSetText("PU8_M5",Frac_counter(8,PERIOD_M5),10,font,upper_rows_color);
   ObjectSetText("PU8_M15",Frac_counter(8,PERIOD_M15),10,font,upper_rows_color);
   ObjectSetText("PU8_M30",Frac_counter(8,PERIOD_M30),10,font,upper_rows_color);
   ObjectSetText("PU8_H1",Frac_counter(8,PERIOD_H1),10,font,upper_rows_color);
   ObjectSetText("PU8_H4",Frac_counter(8,PERIOD_H4),10,font,upper_rows_color);
   ObjectSetText("PU8_D1",Frac_counter(8,PERIOD_D1),10,font,upper_rows_color);
   ObjectSetText("PU8_W1",Frac_counter(8,PERIOD_W1),10,font,upper_rows_color);
   ObjectSetText("PU8_MN",Frac_counter(8,PERIOD_MN1),10,font,upper_rows_color);

   ObjectSetText("PU7_M1",Frac_counter(7,PERIOD_M1),10,font,upper_rows_color);
   ObjectSetText("PU7_M5",Frac_counter(7,PERIOD_M5),10,font,upper_rows_color);
   ObjectSetText("PU7_M15",Frac_counter(7,PERIOD_M15),10,font,upper_rows_color);
   ObjectSetText("PU7_M30",Frac_counter(7,PERIOD_M30),10,font,upper_rows_color);
   ObjectSetText("PU7_H1",Frac_counter(7,PERIOD_H1),10,font,upper_rows_color);
   ObjectSetText("PU7_H4",Frac_counter(7,PERIOD_H4),10,font,upper_rows_color);
   ObjectSetText("PU7_D1",Frac_counter(7,PERIOD_D1),10,font,upper_rows_color);
   ObjectSetText("PU7_W1",Frac_counter(7,PERIOD_W1),10,font,upper_rows_color);
   ObjectSetText("PU7_MN",Frac_counter(7,PERIOD_MN1),10,font,upper_rows_color);   
   ObjectSetText("PU6_M1",Frac_counter(6,PERIOD_M1),10,font,upper_rows_color);
   ObjectSetText("PU6_M5",Frac_counter(6,PERIOD_M5),10,font,upper_rows_color);
   ObjectSetText("PU6_M15",Frac_counter(6,PERIOD_M15),10,font,upper_rows_color);
   ObjectSetText("PU6_M30",Frac_counter(6,PERIOD_M30),10,font,upper_rows_color);
   ObjectSetText("PU6_H1",Frac_counter(6,PERIOD_H1),10,font,upper_rows_color);
   ObjectSetText("PU6_H4",Frac_counter(6,PERIOD_H4),10,font,upper_rows_color);
   ObjectSetText("PU6_D1",Frac_counter(6,PERIOD_D1),10,font,upper_rows_color);
   ObjectSetText("PU6_W1",Frac_counter(6,PERIOD_W1),10,font,upper_rows_color);
   ObjectSetText("PU6_MN",Frac_counter(6,PERIOD_MN1),10,font,upper_rows_color);

   ObjectSetText("PU5_M1",Frac_counter(5,PERIOD_M1),10,font,upper_rows_color);
   ObjectSetText("PU5_M5",Frac_counter(5,PERIOD_M5),10,font,upper_rows_color);
   ObjectSetText("PU5_M15",Frac_counter(5,PERIOD_M15),10,font,upper_rows_color);
   ObjectSetText("PU5_M30",Frac_counter(5,PERIOD_M30),10,font,upper_rows_color);
   ObjectSetText("PU5_H1",Frac_counter(5,PERIOD_H1),10,font,upper_rows_color);
   ObjectSetText("PU5_H4",Frac_counter(5,PERIOD_H4),10,font,upper_rows_color);
   ObjectSetText("PU5_D1",Frac_counter(5,PERIOD_D1),10,font,upper_rows_color);
   ObjectSetText("PU5_W1",Frac_counter(5,PERIOD_W1),10,font,upper_rows_color);
   ObjectSetText("PU5_MN",Frac_counter(5,PERIOD_MN1),10,font,upper_rows_color);

   ObjectSetText("PU4_M1",Frac_counter(4,PERIOD_M1),10,font,upper_rows_color);
   ObjectSetText("PU4_M5",Frac_counter(4,PERIOD_M5),10,font,upper_rows_color);
   ObjectSetText("PU4_M15",Frac_counter(4,PERIOD_M15),10,font,upper_rows_color);
   ObjectSetText("PU4_M30",Frac_counter(4,PERIOD_M30),10,font,upper_rows_color);
   ObjectSetText("PU4_H1",Frac_counter(4,PERIOD_H1),10,font,upper_rows_color);
   ObjectSetText("PU4_H4",Frac_counter(4,PERIOD_H4),10,font,upper_rows_color);
   ObjectSetText("PU4_D1",Frac_counter(4,PERIOD_D1),10,font,upper_rows_color);
   ObjectSetText("PU4_W1",Frac_counter(4,PERIOD_W1),10,font,upper_rows_color);
   ObjectSetText("PU4_MN",Frac_counter(4,PERIOD_MN1),10,font,upper_rows_color);

   ObjectSetText("PU3_M1",Frac_counter(3,PERIOD_M1),10,font,upper_rows_color);
   ObjectSetText("PU3_M5",Frac_counter(3,PERIOD_M5),10,font,upper_rows_color);
   ObjectSetText("PU3_M15",Frac_counter(3,PERIOD_M15),10,font,upper_rows_color);
   ObjectSetText("PU3_M30",Frac_counter(3,PERIOD_M30),10,font,upper_rows_color);
   ObjectSetText("PU3_H1",Frac_counter(3,PERIOD_H1),10,font,upper_rows_color);
   ObjectSetText("PU3_H4",Frac_counter(3,PERIOD_H4),10,font,upper_rows_color);
   ObjectSetText("PU3_D1",Frac_counter(3,PERIOD_D1),10,font,upper_rows_color);
   ObjectSetText("PU3_W1",Frac_counter(3,PERIOD_W1),10,font,upper_rows_color);
   ObjectSetText("PU3_MN",Frac_counter(3,PERIOD_MN1),10,font,upper_rows_color);

   ObjectSetText("PU2_M1",Frac_counter(2,PERIOD_M1),10,font,upper_rows_color);
   ObjectSetText("PU2_M5",Frac_counter(2,PERIOD_M5),10,font,upper_rows_color);
   ObjectSetText("PU2_M15",Frac_counter(2,PERIOD_M15),10,font,upper_rows_color);
   ObjectSetText("PU2_M30",Frac_counter(2,PERIOD_M30),10,font,upper_rows_color);
   ObjectSetText("PU2_H1",Frac_counter(2,PERIOD_H1),10,font,upper_rows_color);
   ObjectSetText("PU2_H4",Frac_counter(2,PERIOD_H4),10,font,upper_rows_color);
   ObjectSetText("PU2_D1",Frac_counter(2,PERIOD_D1),10,font,upper_rows_color);
   ObjectSetText("PU2_W1",Frac_counter(2,PERIOD_W1),10,font,upper_rows_color);
   ObjectSetText("PU2_MN",Frac_counter(2,PERIOD_MN1),10,font,upper_rows_color);

   ObjectSetText("PU1_M1",Frac_counter(1,PERIOD_M1),10,font,upper_rows_color);
   ObjectSetText("PU1_M5",Frac_counter(1,PERIOD_M5),10,font,upper_rows_color);
   ObjectSetText("PU1_M15",Frac_counter(1,PERIOD_M15),10,font,upper_rows_color);
   ObjectSetText("PU1_M30",Frac_counter(1,PERIOD_M30),10,font,upper_rows_color);
   ObjectSetText("PU1_H1",Frac_counter(1,PERIOD_H1),10,font,upper_rows_color);
   ObjectSetText("PU1_H4",Frac_counter(1,PERIOD_H4),10,font,upper_rows_color);
   ObjectSetText("PU1_D1",Frac_counter(1,PERIOD_D1),10,font,upper_rows_color);
   ObjectSetText("PU1_W1",Frac_counter(1,PERIOD_W1),10,font,upper_rows_color);
   ObjectSetText("PU1_MN",Frac_counter(1,PERIOD_MN1),10,font,upper_rows_color);

   ObjectSetText("P_M1",Frac_counter(0,PERIOD_M1),14,font,price_row_color);
   ObjectSetText("P_M5",Frac_counter(0,PERIOD_M5),14,font,price_row_color);
   ObjectSetText("P_M15",Frac_counter(0,PERIOD_M15),14,font,price_row_color);
   ObjectSetText("P_M30",Frac_counter(0,PERIOD_M30),14,font,price_row_color);
   ObjectSetText("P_H1",Frac_counter(0,PERIOD_H1),14,font,price_row_color);
   ObjectSetText("P_H4",Frac_counter(0,PERIOD_H4),14,font,price_row_color);
   ObjectSetText("P_D1",Frac_counter(0,PERIOD_D1),14,font,price_row_color);
   ObjectSetText("P_W1",Frac_counter(0,PERIOD_W1),14,font,price_row_color);
   ObjectSetText("P_MN",Frac_counter(0,PERIOD_MN1),14,font,price_row_color);

   ObjectSetText("PD1_M1",Frac_counter(-1,PERIOD_M1),10,font,lower_rows_color);
   ObjectSetText("PD1_M5",Frac_counter(-1,PERIOD_M5),10,font,lower_rows_color);
   ObjectSetText("PD1_M15",Frac_counter(-1,PERIOD_M15),10,font,lower_rows_color);
   ObjectSetText("PD1_M30",Frac_counter(-1,PERIOD_M30),10,font,lower_rows_color);
   ObjectSetText("PD1_H1",Frac_counter(-1,PERIOD_H1),10,font,lower_rows_color);
   ObjectSetText("PD1_H4",Frac_counter(-1,PERIOD_H4),10,font,lower_rows_color);
   ObjectSetText("PD1_D1",Frac_counter(-1,PERIOD_D1),10,font,lower_rows_color);
   ObjectSetText("PD1_W1",Frac_counter(-1,PERIOD_W1),10,font,lower_rows_color);
   ObjectSetText("PD1_MN",Frac_counter(-1,PERIOD_MN1),10,font,lower_rows_color);

   ObjectSetText("PD2_M1",Frac_counter(-2,PERIOD_M1),10,font,lower_rows_color);
   ObjectSetText("PD2_M5",Frac_counter(-2,PERIOD_M5),10,font,lower_rows_color);
   ObjectSetText("PD2_M15",Frac_counter(-2,PERIOD_M15),10,font,lower_rows_color);
   ObjectSetText("PD2_M30",Frac_counter(-2,PERIOD_M30),10,font,lower_rows_color);
   ObjectSetText("PD2_H1",Frac_counter(-2,PERIOD_H1),10,font,lower_rows_color);
   ObjectSetText("PD2_H4",Frac_counter(-2,PERIOD_H4),10,font,lower_rows_color);
   ObjectSetText("PD2_D1",Frac_counter(-2,PERIOD_D1),10,font,lower_rows_color);
   ObjectSetText("PD2_W1",Frac_counter(-2,PERIOD_W1),10,font,lower_rows_color);
   ObjectSetText("PD2_MN",Frac_counter(-2,PERIOD_MN1),10,font,lower_rows_color);

   ObjectSetText("PD3_M1",Frac_counter(-3,PERIOD_M1),10,font,lower_rows_color);
   ObjectSetText("PD3_M5",Frac_counter(-3,PERIOD_M5),10,font,lower_rows_color);
   ObjectSetText("PD3_M15",Frac_counter(-3,PERIOD_M15),10,font,lower_rows_color);
   ObjectSetText("PD3_M30",Frac_counter(-3,PERIOD_M30),10,font,lower_rows_color);
   ObjectSetText("PD3_H1",Frac_counter(-3,PERIOD_H1),10,font,lower_rows_color);
   ObjectSetText("PD3_H4",Frac_counter(-3,PERIOD_H4),10,font,lower_rows_color);
   ObjectSetText("PD3_D1",Frac_counter(-3,PERIOD_D1),10,font,lower_rows_color);
   ObjectSetText("PD3_W1",Frac_counter(-3,PERIOD_W1),10,font,lower_rows_color);
   ObjectSetText("PD3_MN",Frac_counter(-3,PERIOD_MN1),10,font,lower_rows_color);

   ObjectSetText("PD4_M1",Frac_counter(-4,PERIOD_M1),10,font,lower_rows_color);
   ObjectSetText("PD4_M5",Frac_counter(-4,PERIOD_M5),10,font,lower_rows_color);
   ObjectSetText("PD4_M15",Frac_counter(-4,PERIOD_M15),10,font,lower_rows_color);
   ObjectSetText("PD4_M30",Frac_counter(-4,PERIOD_M30),10,font,lower_rows_color);
   ObjectSetText("PD4_H1",Frac_counter(-4,PERIOD_H1),10,font,lower_rows_color);
   ObjectSetText("PD4_H4",Frac_counter(-4,PERIOD_H4),10,font,lower_rows_color);
   ObjectSetText("PD4_D1",Frac_counter(-4,PERIOD_D1),10,font,lower_rows_color);
   ObjectSetText("PD4_W1",Frac_counter(-4,PERIOD_W1),10,font,lower_rows_color);
   ObjectSetText("PD4_MN",Frac_counter(-4,PERIOD_MN1),10,font,lower_rows_color);

   ObjectSetText("PD5_M1",Frac_counter(-5,PERIOD_M1),10,font,lower_rows_color);
   ObjectSetText("PD5_M5",Frac_counter(-5,PERIOD_M5),10,font,lower_rows_color);
   ObjectSetText("PD5_M15",Frac_counter(-5,PERIOD_M15),10,font,lower_rows_color);
   ObjectSetText("PD5_M30",Frac_counter(-5,PERIOD_M30),10,font,lower_rows_color);
   ObjectSetText("PD5_H1",Frac_counter(-5,PERIOD_H1),10,font,lower_rows_color);
   ObjectSetText("PD5_H4",Frac_counter(-5,PERIOD_H4),10,font,lower_rows_color);
   ObjectSetText("PD5_D1",Frac_counter(-5,PERIOD_D1),10,font,lower_rows_color);
   ObjectSetText("PD5_W1",Frac_counter(-5,PERIOD_W1),10,font,lower_rows_color);
   ObjectSetText("PD5_MN",Frac_counter(-5,PERIOD_MN1),10,font,lower_rows_color);

   ObjectSetText("PD6_M1",Frac_counter(-6,PERIOD_M1),10,font,lower_rows_color);
   ObjectSetText("PD6_M5",Frac_counter(-6,PERIOD_M5),10,font,lower_rows_color);
   ObjectSetText("PD6_M15",Frac_counter(-6,PERIOD_M15),10,font,lower_rows_color);
   ObjectSetText("PD6_M30",Frac_counter(-6,PERIOD_M30),10,font,lower_rows_color);
   ObjectSetText("PD6_H1",Frac_counter(-6,PERIOD_H1),10,font,lower_rows_color);
   ObjectSetText("PD6_H4",Frac_counter(-6,PERIOD_H4),10,font,lower_rows_color);
   ObjectSetText("PD6_D1",Frac_counter(-6,PERIOD_D1),10,font,lower_rows_color);
   ObjectSetText("PD6_W1",Frac_counter(-6,PERIOD_W1),10,font,lower_rows_color);
   ObjectSetText("PD6_MN",Frac_counter(-6,PERIOD_MN1),10,font,lower_rows_color);

   ObjectSetText("PD7_M1",Frac_counter(-7,PERIOD_M1),10,font,lower_rows_color);
   ObjectSetText("PD7_M5",Frac_counter(-7,PERIOD_M5),10,font,lower_rows_color);
   ObjectSetText("PD7_M15",Frac_counter(-7,PERIOD_M15),10,font,lower_rows_color);
   ObjectSetText("PD7_M30",Frac_counter(-7,PERIOD_M30),10,font,lower_rows_color);
   ObjectSetText("PD7_H1",Frac_counter(-7,PERIOD_H1),10,font,lower_rows_color);
   ObjectSetText("PD7_H4",Frac_counter(-7,PERIOD_H4),10,font,lower_rows_color);
   ObjectSetText("PD7_D1",Frac_counter(-7,PERIOD_D1),10,font,lower_rows_color);
   ObjectSetText("PD7_W1",Frac_counter(-7,PERIOD_W1),10,font,lower_rows_color);
   ObjectSetText("PD7_MN",Frac_counter(-7,PERIOD_MN1),10,font,lower_rows_color);

   ObjectSetText("PD8_M1",Frac_counter(-8,PERIOD_M1),10,font,lower_rows_color);
   ObjectSetText("PD8_M5",Frac_counter(-8,PERIOD_M5),10,font,lower_rows_color);
   ObjectSetText("PD8_M15",Frac_counter(-8,PERIOD_M15),10,font,lower_rows_color);
   ObjectSetText("PD8_M30",Frac_counter(-8,PERIOD_M30),10,font,lower_rows_color);
   ObjectSetText("PD8_H1",Frac_counter(-8,PERIOD_H1),10,font,lower_rows_color);
   ObjectSetText("PD8_H4",Frac_counter(-8,PERIOD_H4),10,font,lower_rows_color);
   ObjectSetText("PD8_D1",Frac_counter(-8,PERIOD_D1),10,font,lower_rows_color);
   ObjectSetText("PD8_W1",Frac_counter(-8,PERIOD_W1),10,font,lower_rows_color);
   ObjectSetText("PD8_MN",Frac_counter(-8,PERIOD_MN1),10,font,lower_rows_color);

   ObjectSetText("PD9_M1",Frac_counter(-9,PERIOD_M1),10,font,lower_rows_color);
   ObjectSetText("PD9_M5",Frac_counter(-9,PERIOD_M5),10,font,lower_rows_color);
   ObjectSetText("PD9_M15",Frac_counter(-9,PERIOD_M15),10,font,lower_rows_color);
   ObjectSetText("PD9_M30",Frac_counter(-9,PERIOD_M30),10,font,lower_rows_color);
   ObjectSetText("PD9_H1",Frac_counter(-9,PERIOD_H1),10,font,lower_rows_color);
   ObjectSetText("PD9_H4",Frac_counter(-9,PERIOD_H4),10,font,lower_rows_color);
   ObjectSetText("PD9_D1",Frac_counter(-9,PERIOD_D1),10,font,lower_rows_color);
   ObjectSetText("PD9_W1",Frac_counter(-9,PERIOD_W1),10,font,lower_rows_color);
   ObjectSetText("PD9_MN",Frac_counter(-9,PERIOD_MN1),10,font,lower_rows_color);

   ObjectSetText("PD10_M1",Frac_counter(-10,PERIOD_M1),10,font,lower_rows_color);
   ObjectSetText("PD10_M5",Frac_counter(-10,PERIOD_M5),10,font,lower_rows_color);
   ObjectSetText("PD10_M15",Frac_counter(-10,PERIOD_M15),10,font,lower_rows_color);
   ObjectSetText("PD10_M30",Frac_counter(-10,PERIOD_M30),10,font,lower_rows_color);
   ObjectSetText("PD10_H1",Frac_counter(-10,PERIOD_H1),10,font,lower_rows_color);
   ObjectSetText("PD10_H4",Frac_counter(-10,PERIOD_H4),10,font,lower_rows_color);
   ObjectSetText("PD10_D1",Frac_counter(-10,PERIOD_D1),10,font,lower_rows_color);
   ObjectSetText("PD10_W1",Frac_counter(-10,PERIOD_W1),10,font,lower_rows_color);
   ObjectSetText("PD10_MN",Frac_counter(-10,PERIOD_MN1),10,font,lower_rows_color);

   return(0);
  }
//+----

//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----

   
//----
   return(0);
  }
//+---------------------------------------------------   
   string Frac_counter(int Price_level,int Timeframe)
   {
    int i=search_period;
    int count=0;
    double uptest,downtest;
    string count_s;
    while (i>=0)
      {
       uptest=iHigh(NULL,Timeframe,i);
       if (uptest==Close[0]+Price_level*Point) count++;
       downtest=iLow(NULL,Timeframe,i);
       if (downtest==Close[0]+Price_level*Point) count++;
      i--;
      }
    if(count==0) count_s="";
    else count_s = DoubleToStr(count,0);
    return(count_s);
   }
//-----------------------------------------------------
   void label(string name,int X,int Y)
   {
    ObjectCreate(name,OBJ_LABEL,1,0,0);
    ObjectSet(name,OBJPROP_XDISTANCE,X);
    ObjectSet(name,OBJPROP_YDISTANCE,Y);
   }