//+------------------------------------------------------------------+
//|                                              ivs_CAGOU_TREND.mq4 |
//|                                    Copyright  2008, MQL Service |
//|                                        http://www.mqlservice.com |
//+------------------------------------------------------------------+
//| $Id: //mqlservice/mt4files/experts/indicators/ivs_CAGOU_TREND.mq4#1 $
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, MQL Service"
#property link      "http://www.mqlservice.com"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 LightSeaGreen
#property indicator_level1 0


//---- input parameters
extern int       TimeFrame=0;
extern int       CCI=8;
extern double    Laguerre =0.4;
extern int       RSI=6;
extern int       MACDFastEMA=5;
extern int       MACDSlowEMA=22;
extern int       MACDSignal=4;
extern int       William=20;
extern int       MaxBars = 500;

double MainBuffer[];
string short_name;

int init()
{
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0, MainBuffer);
   short_name="CT("+TimeFrame+","+CCI+","+DoubleToStr(Laguerre,1)+","+RSI+","+MACDFastEMA+","+MACDSlowEMA+","+MACDSignal
                      +","+William+")";
   IndicatorShortName(short_name);
//----
  return(0);
}

int deinit()
{
  return(0);
}

int start()
{
  int limit, i;
  int counted_bars=IndicatorCounted();
  //---- check for possible errors
  if(counted_bars<0) return(-1);
  //---- the last counted bar will be recounted
  if(counted_bars>0) counted_bars--;
  limit=MathMin(Bars-counted_bars, MaxBars);
  //---- main loop
  for(i=0; i<limit; i++)
  {
    int _bs = iBarShift(Symbol(), TimeFrame, Time[i]);
    // Check the MAX CCI in the last 500 bars (this will define the positive ampllitude from 0 to MAX)
    // Check the MIN CCI in the last 500 bars (this will define the negative ampllitude from MIN to 0)
    // Calculate  deviation from 0 ref line( example : 53 will be read as +53  , and  122 will be read  
    // -122 as ref line is Zero)
    // Convert this number in % on the 100% amplitude pos. or neg. of the indicator  (if 100% positive 
    // amplitude is 220, then 53 will be 24% , if 100% 
    // negativ amplitude is 195, then 153 will be -78.46%)
    double _cci = iCCI(Symbol(), TimeFrame, CCI, PRICE_TYPICAL, _bs);
    double _ccimin = _cci;
    double _ccimax = _cci;
    
    for(int j=_bs+1; j<_bs+MaxBars; j++)
    {
      double _cci1 = iCCI(Symbol(), TimeFrame, CCI, PRICE_TYPICAL, j);
      _ccimax = MathMax(_ccimax, _cci1);
      _ccimin = MathMin(_ccimin, _cci1);
    }

    if(_cci < 0)
      _cci = _cci/_ccimin;
    else if(_cci > 0)
      _cci = _cci/_ccimax;
    else
      _cci = 0;
    // Define  positive amplitude (from 0.45 to 1, positive amplitude )
    // Define  negative amplitude (from 0.45 to 0, negative amplitude )
    // Calculate deviation from 0.45 ref line  (90 will be +0.45 and 0.15 will be 0.30 as 4515=30, negative 
    // signal from the 0.45 ref line)
    // Convert this number in % on the 100% amplitude pos. or neg.   of the indicator  (+ 0.45 will be 81.81%, 
    // and  -0.30 will be -66.66 %)
    double _laguerre = iCustom(Symbol(), TimeFrame, "Laguerre", Laguerre, 0, _bs);
    _laguerre = _laguerre-0.45;
    if(_laguerre > 0)
      _laguerre = _laguerre/0.55;
    else 
      _laguerre = _laguerre/0.45;
    // Define  positive amplitude (from 50 to 100, positive amplitude )
    // Define  negative amplitude (from 50 to 0, negative amplitude )
    // Calculate deviation from 50 ref line 
    // Convert this number in % on the 100% amplitude pos. or neg.  of the indicator  ( if reading is +83, 
    // then % will be +66%, and if reding is 10, then % Will be -80%, negative sign)
    double _rsi = iRSI(Symbol(), TimeFrame, RSI, PRICE_CLOSE, _bs);
    _rsi -= 50.0;
    _rsi /= 50.0;
    // Check the MAX MACD in the last 500 bars (this will define the positive ampllitude from 0 to MAX)
    // Check the MIN MACD in the last 500 bars (this will define the negative ampllitude from MIN to 0)
    // Calculate deviation from the zero reference line
    // Convert this number in % on the 100% amplitude pos. or neg.  of the indicator  
    double _macd = iMACD(Symbol(), TimeFrame, MACDFastEMA, MACDSlowEMA, MACDSignal, PRICE_CLOSE, MODE_MAIN, _bs);
    double _macdmin = _macd;
    double _macdmax = _macd;
    for(j=_bs+1; j<_bs+MaxBars; j++)
    {
      double _macd1 = iMACD(Symbol(), TimeFrame, MACDFastEMA, MACDSlowEMA, MACDSignal, PRICE_CLOSE, MODE_MAIN, j);
      _macdmax = MathMax(_macdmax, _macd1);
      _macdmin = MathMin(_macdmin, _macd1);
    }
    if(_macd < 0)
      _macd = _macd/_macdmin;
    else if(_macd > 0)
      _macd = _macd/_macdmax;
    else
      _macd = 0;
    // Define  positive amplitude (from -50 to 0, positive amplitude )
    // Define  negative amplitude (from -50 to -100, negative amplitude )
    // Calculate deviation from -50 ref line 
    // Convert this number in % on the 100% amplitude pos. or neg.  of the indicator 
    // (exemple:if reading is  - 10, then % will be +80%, and if reading is -70, then% will be -40%, negative signal  )
    double _wpr = iWPR(Symbol(), TimeFrame, William, _bs)+50.0;
    _wpr /= 50.0;
    // ADD these 5 number in %  and divide per 5. This  will average the signal. Draw line 
    MainBuffer[i] = (_cci+_laguerre+_rsi+_macd+_wpr)/5.0;

  }
  //---- done
//----
// MQL Service trigger levels:
#include <VisualSignals.mqh>
   string nameb = IND_PREFIX+short_name+BUY_LINE_C; // buy line
   string names = IND_PREFIX+short_name+SELL_LINE_C; // sell line
   string name0 = IND_PREFIX+short_name+IND_BAR_O_C; // current bar
   string name1 = IND_PREFIX+short_name+IND_BAR_1_C; // previous bar
   string name2 = IND_PREFIX+short_name+IND_BAR_2_C; // 2 bars ago
   int win_idx = WindowFind(short_name);
   // buy line
   if(ObjectFind(nameb)<0) ObjectCreate(nameb, OBJ_HLINE, win_idx, TimeCurrent(), MainBuffer[0]);
   ObjectSet(nameb, OBJPROP_COLOR, Blue);
   ObjectSet(nameb, OBJPROP_PRICE1, NormalizeDouble(ObjectGet(nameb, OBJPROP_PRICE1), Digits));
   // sell line
   if(ObjectFind(names)<0) ObjectCreate(names, OBJ_HLINE, win_idx, TimeCurrent(), MainBuffer[1]);
   ObjectSet(names, OBJPROP_COLOR, Red);
   ObjectSet(names, OBJPROP_PRICE1, NormalizeDouble(ObjectGet(names, OBJPROP_PRICE1), Digits));
   // current bar
   if(ObjectFind(name0)<0) ObjectCreate(name0, OBJ_TEXT, win_idx, TimeCurrent(), MainBuffer[0]);
   ObjectSetText(name0, "", 8);
   ObjectSet(name0, OBJPROP_PRICE1, MainBuffer[0]);
   // previous bar
   if(ObjectFind(name1)<0) ObjectCreate(name1, OBJ_TEXT, win_idx, TimeCurrent(), MainBuffer[1]);
   ObjectSetText(name1, "", 8);
   ObjectSet(name1, OBJPROP_PRICE1, MainBuffer[1]);
   // two bars ago
   if(ObjectFind(name2)<0) ObjectCreate(name2, OBJ_TEXT, win_idx, TimeCurrent(), MainBuffer[2]);
   ObjectSetText(name2, "", 8);
   ObjectSet(name2, OBJPROP_PRICE1, MainBuffer[2]);
//----
  return(0);
}

//+---- Programmed by Michal Rutka @ MQLService.com -----------------+